MinGW: Add missing file mode bit defines
[git/dscho.git] / t / test-lib.sh
blobb23a61d0257ba4680cdb083f047c88e3a3535fc4
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 if test -z "$GIT_TEST_CMP"
80 then
81 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
82 then
83 GIT_TEST_CMP="$DIFF -c"
84 else
85 GIT_TEST_CMP="$DIFF -u"
89 # Protect ourselves from common misconfiguration to export
90 # CDPATH into the environment
91 unset CDPATH
93 unset GREP_OPTIONS
95 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
96 1|2|true)
97 echo "* warning: Some tests will not work if GIT_TRACE" \
98 "is set as to trace on STDERR ! *"
99 echo "* warning: Please set GIT_TRACE to something" \
100 "other than 1, 2 or true ! *"
102 esac
104 # Convenience
106 # A regexp to match 5 and 40 hexdigits
107 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
108 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
110 # Each test should start with something like this, after copyright notices:
112 # test_description='Description of this test...
113 # This test checks if command xyzzy does the right thing...
115 # . ./test-lib.sh
116 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
117 TERM=$ORIGINAL_TERM &&
118 export TERM &&
119 [ -t 1 ] &&
120 tput bold >/dev/null 2>&1 &&
121 tput setaf 1 >/dev/null 2>&1 &&
122 tput sgr0 >/dev/null 2>&1
123 ) &&
124 color=t
126 while test "$#" -ne 0
128 case "$1" in
129 -d|--d|--de|--deb|--debu|--debug)
130 debug=t; shift ;;
131 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
132 immediate=t; shift ;;
133 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
134 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
135 -h|--h|--he|--hel|--help)
136 help=t; shift ;;
137 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
138 verbose=t; shift ;;
139 -q|--q|--qu|--qui|--quie|--quiet)
140 quiet=t; shift ;;
141 --with-dashes)
142 with_dashes=t; shift ;;
143 --no-color)
144 color=; shift ;;
145 --no-python)
146 # noop now...
147 shift ;;
148 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
149 valgrind=t; verbose=t; shift ;;
150 --tee)
151 shift ;; # was handled already
152 --root=*)
153 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
154 shift ;;
156 echo "error: unknown test option '$1'" >&2; exit 1 ;;
157 esac
158 done
160 if test -n "$color"; then
161 say_color () {
163 TERM=$ORIGINAL_TERM
164 export TERM
165 case "$1" in
166 error) tput bold; tput setaf 1;; # bold red
167 skip) tput bold; tput setaf 2;; # bold green
168 pass) tput setaf 2;; # green
169 info) tput setaf 3;; # brown
170 *) test -n "$quiet" && return;;
171 esac
172 shift
173 printf "* %s" "$*"
174 tput sgr0
175 echo
178 else
179 say_color() {
180 test -z "$1" && test -n "$quiet" && return
181 shift
182 echo "* $*"
186 error () {
187 say_color error "error: $*"
188 GIT_EXIT_OK=t
189 exit 1
192 say () {
193 say_color info "$*"
196 test "${test_description}" != "" ||
197 error "Test script did not set test_description."
199 if test "$help" = "t"
200 then
201 echo "$test_description"
202 exit 0
205 exec 5>&1
206 if test "$verbose" = "t"
207 then
208 exec 4>&2 3>&1
209 else
210 exec 4>/dev/null 3>/dev/null
213 test_failure=0
214 test_count=0
215 test_fixed=0
216 test_broken=0
217 test_success=0
219 die () {
220 code=$?
221 if test -n "$GIT_EXIT_OK"
222 then
223 exit $code
224 else
225 echo >&5 "FATAL: Unexpected exit with code $code"
226 exit 1
230 GIT_EXIT_OK=
231 trap 'die' EXIT
233 # The semantics of the editor variables are that of invoking
234 # sh -c "$EDITOR \"$@\"" files ...
236 # If our trash directory contains shell metacharacters, they will be
237 # interpreted if we just set $EDITOR directly, so do a little dance with
238 # environment variables to work around this.
240 # In particular, quoting isn't enough, as the path may contain the same quote
241 # that we're using.
242 test_set_editor () {
243 FAKE_EDITOR="$1"
244 export FAKE_EDITOR
245 EDITOR='"$FAKE_EDITOR"'
246 export EDITOR
249 test_decode_color () {
250 sed -e 's/.\[1m/<WHITE>/g' \
251 -e 's/.\[31m/<RED>/g' \
252 -e 's/.\[32m/<GREEN>/g' \
253 -e 's/.\[33m/<YELLOW>/g' \
254 -e 's/.\[34m/<BLUE>/g' \
255 -e 's/.\[35m/<MAGENTA>/g' \
256 -e 's/.\[36m/<CYAN>/g' \
257 -e 's/.\[m/<RESET>/g'
260 q_to_nul () {
261 perl -pe 'y/Q/\000/'
264 q_to_cr () {
265 tr Q '\015'
268 append_cr () {
269 sed -e 's/$/Q/' | tr Q '\015'
272 remove_cr () {
273 tr '\015' Q | sed -e 's/Q$//'
276 test_tick () {
277 if test -z "${test_tick+set}"
278 then
279 test_tick=1112911993
280 else
281 test_tick=$(($test_tick + 60))
283 GIT_COMMITTER_DATE="$test_tick -0700"
284 GIT_AUTHOR_DATE="$test_tick -0700"
285 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
288 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
290 # This will commit a file with the given contents and the given commit
291 # message. It will also add a tag with <message> as name.
293 # Both <file> and <contents> default to <message>.
295 test_commit () {
296 file=${2:-"$1.t"}
297 echo "${3-$1}" > "$file" &&
298 git add "$file" &&
299 test_tick &&
300 git commit -m "$1" &&
301 git tag "$1"
304 # Call test_merge with the arguments "<message> <commit>", where <commit>
305 # can be a tag pointing to the commit-to-merge.
307 test_merge () {
308 test_tick &&
309 git merge -m "$1" "$2" &&
310 git tag "$1"
313 # This function helps systems where core.filemode=false is set.
314 # Use it instead of plain 'chmod +x' to set or unset the executable bit
315 # of a file in the working directory and add it to the index.
317 test_chmod () {
318 chmod "$@" &&
319 git update-index --add "--chmod=$@"
322 # Use test_set_prereq to tell that a particular prerequisite is available.
323 # The prerequisite can later be checked for in two ways:
325 # - Explicitly using test_have_prereq.
327 # - Implicitly by specifying the prerequisite tag in the calls to
328 # test_expect_{success,failure,code}.
330 # The single parameter is the prerequisite tag (a simple word, in all
331 # capital letters by convention).
333 test_set_prereq () {
334 satisfied="$satisfied$1 "
336 satisfied=" "
338 test_have_prereq () {
339 case $satisfied in
340 *" $1 "*)
341 : yes, have it ;;
343 ! : nope ;;
344 esac
347 # You are not expected to call test_ok_ and test_failure_ directly, use
348 # the text_expect_* functions instead.
350 test_ok_ () {
351 test_success=$(($test_success + 1))
352 say_color "" " ok $test_count: $@"
355 test_failure_ () {
356 test_failure=$(($test_failure + 1))
357 say_color error "FAIL $test_count: $1"
358 shift
359 echo "$@" | sed -e 's/^/ /'
360 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
363 test_known_broken_ok_ () {
364 test_fixed=$(($test_fixed+1))
365 say_color "" " FIXED $test_count: $@"
368 test_known_broken_failure_ () {
369 test_broken=$(($test_broken+1))
370 say_color skip " still broken $test_count: $@"
373 test_debug () {
374 test "$debug" = "" || eval "$1"
377 test_run_ () {
378 test_cleanup=:
379 eval >&3 2>&4 "$1"
380 eval_ret=$?
381 eval >&3 2>&4 "$test_cleanup"
382 return 0
385 test_skip () {
386 test_count=$(($test_count+1))
387 to_skip=
388 for skp in $GIT_SKIP_TESTS
390 case $this_test.$test_count in
391 $skp)
392 to_skip=t
393 esac
394 done
395 if test -z "$to_skip" && test -n "$prereq" &&
396 ! test_have_prereq "$prereq"
397 then
398 to_skip=t
400 case "$to_skip" in
402 say_color skip >&3 "skipping test: $@"
403 say_color skip "skip $test_count: $1"
404 : true
407 false
409 esac
412 test_expect_failure () {
413 test "$#" = 3 && { prereq=$1; shift; } || prereq=
414 test "$#" = 2 ||
415 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
416 if ! test_skip "$@"
417 then
418 say >&3 "checking known breakage: $2"
419 test_run_ "$2"
420 if [ "$?" = 0 -a "$eval_ret" = 0 ]
421 then
422 test_known_broken_ok_ "$1"
423 else
424 test_known_broken_failure_ "$1"
427 echo >&3 ""
430 test_expect_success () {
431 test "$#" = 3 && { prereq=$1; shift; } || prereq=
432 test "$#" = 2 ||
433 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
434 if ! test_skip "$@"
435 then
436 say >&3 "expecting success: $2"
437 test_run_ "$2"
438 if [ "$?" = 0 -a "$eval_ret" = 0 ]
439 then
440 test_ok_ "$1"
441 else
442 test_failure_ "$@"
445 echo >&3 ""
448 test_expect_code () {
449 test "$#" = 4 && { prereq=$1; shift; } || prereq=
450 test "$#" = 3 ||
451 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
452 if ! test_skip "$@"
453 then
454 say >&3 "expecting exit code $1: $3"
455 test_run_ "$3"
456 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
457 then
458 test_ok_ "$2"
459 else
460 test_failure_ "$@"
463 echo >&3 ""
466 # test_external runs external test scripts that provide continuous
467 # test output about their progress, and succeeds/fails on
468 # zero/non-zero exit code. It outputs the test output on stdout even
469 # in non-verbose mode, and announces the external script with "* run
470 # <n>: ..." before running it. When providing relative paths, keep in
471 # mind that all scripts run in "trash directory".
472 # Usage: test_external description command arguments...
473 # Example: test_external 'Perl API' perl ../path/to/test.pl
474 test_external () {
475 test "$#" = 4 && { prereq=$1; shift; } || prereq=
476 test "$#" = 3 ||
477 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
478 descr="$1"
479 shift
480 if ! test_skip "$descr" "$@"
481 then
482 # Announce the script to reduce confusion about the
483 # test output that follows.
484 say_color "" " run $test_count: $descr ($*)"
485 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
486 # to be able to use them in script
487 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
488 # Run command; redirect its stderr to &4 as in
489 # test_run_, but keep its stdout on our stdout even in
490 # non-verbose mode.
491 "$@" 2>&4
492 if [ "$?" = 0 ]
493 then
494 test_ok_ "$descr"
495 else
496 test_failure_ "$descr" "$@"
501 # Like test_external, but in addition tests that the command generated
502 # no output on stderr.
503 test_external_without_stderr () {
504 # The temporary file has no (and must have no) security
505 # implications.
506 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
507 stderr="$tmp/git-external-stderr.$$.tmp"
508 test_external "$@" 4> "$stderr"
509 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
510 descr="no stderr: $1"
511 shift
512 say >&3 "expecting no stderr from previous command"
513 if [ ! -s "$stderr" ]; then
514 rm "$stderr"
515 test_ok_ "$descr"
516 else
517 if [ "$verbose" = t ]; then
518 output=`echo; echo Stderr is:; cat "$stderr"`
519 else
520 output=
522 # rm first in case test_failure exits.
523 rm "$stderr"
524 test_failure_ "$descr" "$@" "$output"
528 # This is not among top-level (test_expect_success | test_expect_failure)
529 # but is a prefix that can be used in the test script, like:
531 # test_expect_success 'complain and die' '
532 # do something &&
533 # do something else &&
534 # test_must_fail git checkout ../outerspace
537 # Writing this as "! git checkout ../outerspace" is wrong, because
538 # the failure could be due to a segv. We want a controlled failure.
540 test_must_fail () {
541 "$@"
542 test $? -gt 0 -a $? -le 129 -o $? -gt 192
545 # Similar to test_must_fail, but tolerates success, too. This is
546 # meant to be used in contexts like:
548 # test_expect_success 'some command works without configuration' '
549 # test_might_fail git config --unset all.configuration &&
550 # do something
553 # Writing "git config --unset all.configuration || :" would be wrong,
554 # because we want to notice if it fails due to segv.
556 test_might_fail () {
557 "$@"
558 test $? -ge 0 -a $? -le 129 -o $? -gt 192
561 # test_cmp is a helper function to compare actual and expected output.
562 # You can use it like:
564 # test_expect_success 'foo works' '
565 # echo expected >expected &&
566 # foo >actual &&
567 # test_cmp expected actual
570 # This could be written as either "cmp" or "diff -u", but:
571 # - cmp's output is not nearly as easy to read as diff -u
572 # - not all diff versions understand "-u"
574 test_cmp() {
575 $GIT_TEST_CMP "$@"
578 # This function can be used to schedule some commands to be run
579 # unconditionally at the end of the test to restore sanity:
581 # test_expect_success 'test core.capslock' '
582 # git config core.capslock true &&
583 # test_when_finished "git config --unset core.capslock" &&
584 # hello world
587 # That would be roughly equivalent to
589 # test_expect_success 'test core.capslock' '
590 # git config core.capslock true &&
591 # hello world
592 # git config --unset core.capslock
595 # except that the greeting and config --unset must both succeed for
596 # the test to pass.
598 test_when_finished () {
599 test_cleanup="{ $*
600 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
603 # Most tests can use the created repository, but some may need to create more.
604 # Usage: test_create_repo <directory>
605 test_create_repo () {
606 test "$#" = 1 ||
607 error "bug in the test script: not 1 parameter to test-create-repo"
608 owd=`pwd`
609 repo="$1"
610 mkdir -p "$repo"
611 cd "$repo" || error "Cannot setup test environment"
612 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
613 error "cannot run git init -- have you built things yet?"
614 mv .git/hooks .git/hooks-disabled
615 cd "$owd"
618 test_done () {
619 GIT_EXIT_OK=t
620 test_results_dir="$TEST_DIRECTORY/test-results"
621 mkdir -p "$test_results_dir"
622 test_results_path="$test_results_dir/${0%.sh}-$$"
624 echo "total $test_count" >> $test_results_path
625 echo "success $test_success" >> $test_results_path
626 echo "fixed $test_fixed" >> $test_results_path
627 echo "broken $test_broken" >> $test_results_path
628 echo "failed $test_failure" >> $test_results_path
629 echo "" >> $test_results_path
631 if test "$test_fixed" != 0
632 then
633 say_color pass "fixed $test_fixed known breakage(s)"
635 if test "$test_broken" != 0
636 then
637 say_color error "still have $test_broken known breakage(s)"
638 msg="remaining $(($test_count-$test_broken)) test(s)"
639 else
640 msg="$test_count test(s)"
642 case "$test_failure" in
644 say_color pass "passed all $msg"
646 test -d "$remove_trash" &&
647 cd "$(dirname "$remove_trash")" &&
648 rm -rf "$(basename "$remove_trash")"
650 exit 0 ;;
653 say_color error "failed $test_failure among $msg"
654 exit 1 ;;
656 esac
659 # Test the binaries we have just built. The tests are kept in
660 # t/ subdirectory and are run in 'trash directory' subdirectory.
661 TEST_DIRECTORY=$(pwd)
662 if test -n "$valgrind"
663 then
664 make_symlink () {
665 test -h "$2" &&
666 test "$1" = "$(readlink "$2")" || {
667 # be super paranoid
668 if mkdir "$2".lock
669 then
670 rm -f "$2" &&
671 ln -s "$1" "$2" &&
672 rm -r "$2".lock
673 else
674 while test -d "$2".lock
676 say "Waiting for lock on $2."
677 sleep 1
678 done
683 make_valgrind_symlink () {
684 # handle only executables
685 test -x "$1" || return
687 base=$(basename "$1")
688 symlink_target=$TEST_DIRECTORY/../$base
689 # do not override scripts
690 if test -x "$symlink_target" &&
691 test ! -d "$symlink_target" &&
692 test "#!" != "$(head -c 2 < "$symlink_target")"
693 then
694 symlink_target=../valgrind.sh
696 case "$base" in
697 *.sh|*.perl)
698 symlink_target=../unprocessed-script
699 esac
700 # create the link, or replace it if it is out of date
701 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
704 # override all git executables in TEST_DIRECTORY/..
705 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
706 mkdir -p "$GIT_VALGRIND"/bin
707 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
709 make_valgrind_symlink $file
710 done
711 OLDIFS=$IFS
712 IFS=:
713 for path in $PATH
715 ls "$path"/git-* 2> /dev/null |
716 while read file
718 make_valgrind_symlink "$file"
719 done
720 done
721 IFS=$OLDIFS
722 PATH=$GIT_VALGRIND/bin:$PATH
723 GIT_EXEC_PATH=$GIT_VALGRIND/bin
724 export GIT_VALGRIND
725 elif test -n "$GIT_TEST_INSTALLED" ; then
726 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
727 error "Cannot run git from $GIT_TEST_INSTALLED."
728 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
729 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
730 else # normal case, use ../bin-wrappers only unless $with_dashes:
731 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
732 if ! test -x "$git_bin_dir/git" ; then
733 if test -z "$with_dashes" ; then
734 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
736 with_dashes=t
738 PATH="$git_bin_dir:$PATH"
739 GIT_EXEC_PATH=$TEST_DIRECTORY/..
740 if test -n "$with_dashes" ; then
741 PATH="$TEST_DIRECTORY/..:$PATH"
744 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
745 unset GIT_CONFIG
746 GIT_CONFIG_NOSYSTEM=1
747 GIT_CONFIG_NOGLOBAL=1
748 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
750 . ../GIT-BUILD-OPTIONS
752 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
753 export GITPERLLIB
754 test -d ../templates/blt || {
755 error "You haven't built things yet, have you?"
758 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
759 then
760 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
761 export GITPYTHONLIB
762 test -d ../git_remote_helpers/build || {
763 error "You haven't built git_remote_helpers yet, have you?"
767 if ! test -x ../test-chmtime; then
768 echo >&2 'You need to build test-chmtime:'
769 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
770 exit 1
773 # Test repository
774 test="trash directory.$(basename "$0" .sh)"
775 test -n "$root" && test="$root/$test"
776 case "$test" in
777 /*) TRASH_DIRECTORY="$test" ;;
778 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
779 esac
780 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
781 rm -fr "$test" || {
782 GIT_EXIT_OK=t
783 echo >&5 "FATAL: Cannot prepare test area"
784 exit 1
787 test_create_repo "$test"
788 # Use -P to resolve symlinks in our working directory so that the cwd
789 # in subprocesses like git equals our $PWD (for pathname comparisons).
790 cd -P "$test" || exit 1
792 this_test=${0##*/}
793 this_test=${this_test%%-*}
794 for skp in $GIT_SKIP_TESTS
796 to_skip=
797 for skp in $GIT_SKIP_TESTS
799 case "$this_test" in
800 $skp)
801 to_skip=t
802 esac
803 done
804 case "$to_skip" in
806 say_color skip >&3 "skipping test $this_test altogether"
807 say_color skip "skip all tests in $this_test"
808 test_done
809 esac
810 done
812 # Provide an implementation of the 'yes' utility
813 yes () {
814 if test $# = 0
815 then
817 else
818 y="$*"
821 while echo "$y"
824 done
827 # Fix some commands on Windows
828 case $(uname -s) in
829 *MINGW*)
830 # Windows has its own (incompatible) sort and find
831 sort () {
832 /usr/bin/sort "$@"
834 find () {
835 /usr/bin/find "$@"
837 sum () {
838 md5sum "$@"
840 # git sees Windows-style pwd
841 pwd () {
842 builtin pwd -W
844 # no POSIX permissions
845 # backslashes in pathspec are converted to '/'
846 # exec does not inherit the PID
849 test_set_prereq POSIXPERM
850 test_set_prereq BSLASHPSPEC
851 test_set_prereq EXECKEEPSPID
853 esac
855 test -z "$NO_PERL" && test_set_prereq PERL
856 test -z "$NO_PYTHON" && test_set_prereq PYTHON
858 # test whether the filesystem supports symbolic links
859 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
860 rm -f y